TITLE "Qmail 4 QWK/REP run (Full conf list)"
;--------------------------------------------------------------------
; QCONFS.RS -- Qmail 4 Door Mail run (retrieves full conferences list)
;....................................................................
PARAMETER 1 "BBS/QWK ID                (8 chars max)"
PARAMETER 2 "Incoming QWK dir   (include ending '\')"
PARAMETER 3 "Outgoing REP dir   (include ending '\')"
PARAMETER 4 "Hang up after sending REP         (Y/N)"
PARAMETER 5 "Mail run log file            (optional)"
ENDPARAMS

   ; Verify that the 3 necessary parameters were entered.
   IF EMPTY "%P1%" GOTO PARAM_ERROR
   IF EMPTY "%P2%" GOTO PARAM_ERROR
   IF EMPTY "%P3%" GOTO PARAM_ERROR

   ; Set up capture file
   ; Change "overwrite" below to "append" if desired.
   IF NOT EMPTY "%P5%" CAPTURE "%P5%" OVERWRITE

   ; Default to five minutes to scan for mail.
   ; Edit this if desired
   TIMEOUT 300

   ; Get to mail door
   VENUE MAIL

   ; Send replies first
   GOSUB SENDREP

   ; Wait for the command line
   WAITFOR "Command?" FAILURE SEND "|"

   ; Request the packet
   SEND "D CONFS|"

   WHEN "%BBS43%" SEND "Y|"
   WHEN "%BBS44%" GOTO SENDREP
   WAITFOR "%BBS41%" FAILURE GOTO SLOW_BBS

   ; Keep 3 old QWK packets by default.
   ; Edit this if desired.
   IF EXIST "%P2%%P1%.QWK" RENUMBER "%P2%%P1%.QWK" 3

   ; Download the QWK packet.
   MESSAGE "Downloading %P2%%P1%.QWK"
   DOWNLOAD "%P2%%P1%.QWK" USING "%BBS22%"

   WAITFOR "Command?" FAILURE SEND "|"
GOTO ENDRUN

:SENDREP
   IF NOT EXIST "%P3%%P1%.REP" GOTO NOREP
   SEND "U|"
   WAITFOR "%BBS42%" FAILURE GOTO I_AM_LOST
   MESSAGE "Uploading %P3%%P1%.REP"
   UPLOAD "%P3%%P1%.REP" USING  "%BBS21%"
   ; Will keep up to 3 old rep packets.  Edit if desired.
   RENUMBER "%P3%%P1%.REP" 3
RETURN

:NOREP
   MESSAGE "No %P3%%P1%.REP to send"
RETURN

:ENDRUN
   IF YES "%P5%" GOTO DROP_CARRIER
   CLOSE
EXIT 0

:DROP_CARRIER
   MESSAGE "Dropping carrier per request"
   HANGUP
   CLOSE
EXIT 0


:SLOW_BBS
   MESSAGE "^UERROR:^U Timeout during mail run."
   HANGUP
   CLOSE
EXIT 1

:I_AM_LOST
   MESSAGE "^UERROR:^U Sorry - I am lost."
   HANGUP
   CLOSE
EXIT 1

:PARAM_ERROR
   MESSAGE "^UERROR:^U Parameters 1, 2 and 3 are required!"
   CLOSE
EXIT 1

;eof